<?php
/*
Plugin Name: Redirect Buddy
Plugin URI: http://pluginsforyou.com/redirect-buddy/
Version: 1.1
Author: Chris Jenkins - Atheer Fendi
Author URI: http://onlinesuccesswithchris.com
Description: Once installed and activated, you see a new menu item and if you click it you end up on a page where you can enter a URL and a number of days. You enter a URL that you want traffic to be redirected to and a number of days after the vistor's initial visit for it to trigger. So, if you want to redirect first time visitors to a special offer or welcome page, you will add the URL and set the number of days to zero. But you can also add further redirects based on the number of days since their initial visit. / <a href="http://pluginsforyou.com/redirect-buddy-license/">License File</a>
License: Restricted Single User License
License URI: http://pluginsforyou.com/redirect-buddy-license/
*/

global $basepath, $baseurl, $ajax_url;

include_once('includes/view.php');
include_once('includes/db-functions.php');
include_once('includes/lang_en.php');
include_once('includes/vars.php');

add_action('plugins_loaded', 'nv_init');

function nv_init(){
	global $basepathm, $baseurl, $ajax_url;
	$basepath = str_replace('\\', '/', WP_PLUGIN_DIR . '/' . basename(dirname(__FILE__)));
	$baseurl = str_replace('\\', '/', WP_PLUGIN_URL . '/' . basename(dirname(__FILE__)));
	$ajax_url = $baseurl . '/includes/ajax.php';
	wp_enqueue_script('nv-script', $baseurl . '/scripts/functions.js');
	wp_enqueue_style('nv-style', $baseurl . '/styles/style.css');
}

register_activation_hook(__FILE__, 'nv_activate');

function nv_activate(){
	nv_db_create_table();
}

add_action('admin_menu', 'nv_menu');

function nv_menu(){
	add_menu_page(NV_TITLE, NV_TITLE, 'administrator', NV_PAGE, 'nv_main_page');
	add_submenu_page($page, NV_NEWS, NV_NEWS, 'administrator', 'nv-news', 'nv_display_news');
}

function nv_main_page(){
	$sub = $_GET['subpage'];
	switch($sub){
		case 'add-new':
			$success = -1;
			$newid = 0;
			if($_POST['url'] != ''){
				$params['url'] = addslashes($_POST['url']);
				$params['days'] = stripslashes($_POST['num_days']);
				if(nv_db_insert_row($params, &$newid) !== false)
					$success = 1; //successfull
				else
					$success = 0; //not successfull
			}
			
			nv_display_add_new($success, $newid);
			break;
		case 'main':
			nv_display_url_lists();
			break;
		case 'edit':
			$success = -1;
			$newid = $_GET['id'];
			if($_POST['url'] != ''){
				$params['url'] = addslashes($_POST['url']);
				$params['days'] = stripslashes($_POST['num_days']);
				if(nv_db_update_row($newid, $params) !== false)
					$success = 1; //successfull
				else
					$success = 0; //not successfull
			}
			
			nv_display_update($success, $newid);			
			break;
		default:
			nv_display_url_lists();
	}
}

/**
RESET COOKIE
setcookie('nv_timestamp', 0);
setcookie('nv_urlid', '');
echo $_COOKIE['nv_timestamp'];
echo $_COOKIE['nv_urlid'];
*/

add_action('template_redirect', 'nv_redirect');
				
function nv_redirect(){
	if(is_home()){
		$cookietime = ($_COOKIE['nv_timestamp'] != '') ? $_COOKIE['nv_timestamp'] : 0;
		$rows = nv_db_retrieve_allrows();
		if(!nv_is_exists($_COOKIE['nv_urlid']) && $_COOKIE['nv_urlid'] != ''){
			$previd = nv_db_get_prev($_COOKIE['nv_urlid']);
		}
		else{
			$previd = $_COOKIE['nv_urlid'];
		}

		foreach($rows as $r){			
			$daystosec = $r->days * 60 * 60 * 24;
			$cur_time = time();
			if($cur_time >= ($daystosec + $cookietime)){
				if($previous == $previd || $previd == ''){
					setcookie('nv_timestamp', $cur_time);
					setcookie('nv_urlid', $r->ID);	
					header('Location: ' . $r->url);
					break;
				}
			}
			$previous = $r->ID;
		}		
	}
}
?>